# This file is autogenerated
import threading
import ctypes
import os
from pyautd3.native_methods.structs import Vector3, Quaternion, FfiFuture, LocalFfiFuture
from pyautd3.native_methods.autd3_driver import SamplingConfig, LoopBehavior, SyncMode, GainSTMMode, GPIOOut, GPIOIn, Segment, SilencerTarget, Drive, DcSysTime
from pyautd3.native_methods.autd3capi_driver import ControllerBuilderPtr, ControllerPtr, DatagramPtr, DebugTypeWrap, DevicePtr, Duration, DynSincInterpolator, FociSTMPtr, GainPtr, GainSTMPtr, GeometryPtr, HandlePtr, LinkBuilderPtr, LinkPtr, ModulationPtr, OptionDuration, ResultFociSTM, ResultGainSTM, ResultModulation, ResultSamplingConfig, ResultStatus, RuntimePtr, SpinStrategyTag, TimerStrategyWrap, TransducerPtr, TransitionModeWrap


class FPGAStateListPtr(ctypes.Structure):
    _fields_ = [("_0", ctypes.c_void_p)]


class FirmwareVersionListPtr(ctypes.Structure):
    _fields_ = [("_0", ctypes.c_void_p)]


class GainCachePtr(ctypes.Structure):
    _fields_ = [("_0", ctypes.c_void_p)]


class GroupGainMapPtr(ctypes.Structure):
    _fields_ = [("_0", ctypes.c_void_p)]


class ModulationCachePtr(ctypes.Structure):
    _fields_ = [("_0", ctypes.c_void_p)]


class ResultController(ctypes.Structure):
    _fields_ = [("result", ControllerPtr), ("err_len", ctypes.c_uint32), ("err", ctypes.c_void_p)]

    def __eq__(self, other: object) -> bool:
        return isinstance(other, ResultController) and self._fields_ == other._fields_  # pragma: no cover


class ResultFPGAStateList(ctypes.Structure):
    _fields_ = [("result", FPGAStateListPtr), ("err_len", ctypes.c_uint32), ("err", ctypes.c_void_p)]

    def __eq__(self, other: object) -> bool:
        return isinstance(other, ResultFPGAStateList) and self._fields_ == other._fields_  # pragma: no cover


class ResultFirmwareVersionList(ctypes.Structure):
    _fields_ = [("result", FirmwareVersionListPtr), ("err_len", ctypes.c_uint32), ("err", ctypes.c_void_p)]

    def __eq__(self, other: object) -> bool:
        return isinstance(other, ResultFirmwareVersionList) and self._fields_ == other._fields_  # pragma: no cover



class Singleton(type):
    _instances = {}  # type: ignore
    _lock = threading.Lock()

    def __call__(cls, *args, **kwargs):
        if cls not in cls._instances:
            with cls._lock:
                if cls not in cls._instances: # pragma: no cover
                    cls._instances[cls] = super(Singleton, cls).__call__(*args, **kwargs)
        return cls._instances[cls]


class NativeMethods(metaclass=Singleton):

    def init_dll(self, bin_location: str, bin_prefix: str, bin_ext: str):
        self.dll = ctypes.CDLL(os.path.join(bin_location, f'{bin_prefix}autd3capi{bin_ext}'))

        self.dll.AUTDControllerBuilder.argtypes = [ctypes.POINTER(Vector3), ctypes.POINTER(Quaternion), ctypes.c_uint16, ctypes.c_uint16, Duration, Duration, Duration, TimerStrategyWrap]  # type: ignore 
        self.dll.AUTDControllerBuilder.restype = ControllerBuilderPtr

        self.dll.AUTDControllerBuilderIsDefault.argtypes = [ctypes.c_uint16, Duration, Duration, Duration, TimerStrategyWrap]  # type: ignore 
        self.dll.AUTDControllerBuilderIsDefault.restype = ctypes.c_bool

        self.dll.AUTDControllerOpen.argtypes = [ControllerBuilderPtr, LinkBuilderPtr, OptionDuration]  # type: ignore 
        self.dll.AUTDControllerOpen.restype = FfiFuture

        self.dll.AUTDControllerGroup.argtypes = [ControllerPtr, ctypes.c_void_p, ctypes.c_void_p, GeometryPtr, ctypes.POINTER(ctypes.c_int32), ctypes.POINTER(DatagramPtr), ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDControllerGroup.restype = LocalFfiFuture

        self.dll.AUTDControllerClose.argtypes = [ControllerPtr]  # type: ignore 
        self.dll.AUTDControllerClose.restype = FfiFuture

        self.dll.AUTDControllerFPGAState.argtypes = [ControllerPtr]  # type: ignore 
        self.dll.AUTDControllerFPGAState.restype = FfiFuture

        self.dll.AUTDControllerFPGAStateGet.argtypes = [FPGAStateListPtr, ctypes.c_uint32]  # type: ignore 
        self.dll.AUTDControllerFPGAStateGet.restype = ctypes.c_int16

        self.dll.AUTDControllerFPGAStateDelete.argtypes = [FPGAStateListPtr]  # type: ignore 
        self.dll.AUTDControllerFPGAStateDelete.restype = None

        self.dll.AUTDControllerFirmwareVersionListPointer.argtypes = [ControllerPtr]  # type: ignore 
        self.dll.AUTDControllerFirmwareVersionListPointer.restype = FfiFuture

        self.dll.AUTDControllerFirmwareVersionGet.argtypes = [FirmwareVersionListPtr, ctypes.c_uint32, ctypes.c_char_p]  # type: ignore 
        self.dll.AUTDControllerFirmwareVersionGet.restype = None

        self.dll.AUTDControllerFirmwareVersionListPointerDelete.argtypes = [FirmwareVersionListPtr]  # type: ignore 
        self.dll.AUTDControllerFirmwareVersionListPointerDelete.restype = None

        self.dll.AUTDFirmwareLatest.argtypes = [ctypes.c_char_p] 
        self.dll.AUTDFirmwareLatest.restype = None

        self.dll.AUTDControllerSend.argtypes = [ControllerPtr, DatagramPtr]  # type: ignore 
        self.dll.AUTDControllerSend.restype = FfiFuture

        self.dll.AUTDTimerStrategyStd.argtypes = [ctypes.c_uint32] 
        self.dll.AUTDTimerStrategyStd.restype = TimerStrategyWrap

        self.dll.AUTDTimerStrategySpinDefaultAccuracy.argtypes = [] 
        self.dll.AUTDTimerStrategySpinDefaultAccuracy.restype = ctypes.c_uint32

        self.dll.AUTDTimerStrategySpin.argtypes = [ctypes.c_uint32, SpinStrategyTag]  # type: ignore 
        self.dll.AUTDTimerStrategySpin.restype = TimerStrategyWrap

        self.dll.AUTDTimerStrategyAsync.argtypes = [ctypes.c_uint32] 
        self.dll.AUTDTimerStrategyAsync.restype = TimerStrategyWrap

        self.dll.AUTDTimerStrategyWaitable.argtypes = [] 
        self.dll.AUTDTimerStrategyWaitable.restype = TimerStrategyWrap

        self.dll.AUTDDatagramClear.argtypes = [] 
        self.dll.AUTDDatagramClear.restype = DatagramPtr

        self.dll.AUTDDatagramDebugSettings.argtypes = [ctypes.c_void_p, ctypes.c_void_p, GeometryPtr]  # type: ignore 
        self.dll.AUTDDatagramDebugSettings.restype = DatagramPtr

        self.dll.AUTDDatagramForceFan.argtypes = [ctypes.c_void_p, ctypes.c_void_p, GeometryPtr]  # type: ignore 
        self.dll.AUTDDatagramForceFan.restype = DatagramPtr

        self.dll.AUTDDatagramTuple.argtypes = [DatagramPtr, DatagramPtr]  # type: ignore 
        self.dll.AUTDDatagramTuple.restype = DatagramPtr

        self.dll.AUTDDatagramPhaseCorr.argtypes = [ctypes.c_void_p, ctypes.c_void_p, GeometryPtr]  # type: ignore 
        self.dll.AUTDDatagramPhaseCorr.restype = DatagramPtr

        self.dll.AUTDDatagramPulseWidthEncoder.argtypes = [ctypes.c_void_p, ctypes.c_void_p, GeometryPtr]  # type: ignore 
        self.dll.AUTDDatagramPulseWidthEncoder.restype = DatagramPtr

        self.dll.AUTDDatagramPulseWidthEncoderDefault.argtypes = [] 
        self.dll.AUTDDatagramPulseWidthEncoderDefault.restype = DatagramPtr

        self.dll.AUTDDatagramReadsFPGAState.argtypes = [ctypes.c_void_p, ctypes.c_void_p, GeometryPtr]  # type: ignore 
        self.dll.AUTDDatagramReadsFPGAState.restype = DatagramPtr

        self.dll.AUTDDatagramSwapSegmentModulation.argtypes = [Segment, TransitionModeWrap]  # type: ignore 
        self.dll.AUTDDatagramSwapSegmentModulation.restype = DatagramPtr

        self.dll.AUTDDatagramSwapSegmentFociSTM.argtypes = [Segment, TransitionModeWrap]  # type: ignore 
        self.dll.AUTDDatagramSwapSegmentFociSTM.restype = DatagramPtr

        self.dll.AUTDDatagramSwapSegmentGainSTM.argtypes = [Segment, TransitionModeWrap]  # type: ignore 
        self.dll.AUTDDatagramSwapSegmentGainSTM.restype = DatagramPtr

        self.dll.AUTDDatagramSwapSegmentGain.argtypes = [Segment, TransitionModeWrap]  # type: ignore 
        self.dll.AUTDDatagramSwapSegmentGain.restype = DatagramPtr

        self.dll.AUTDDatagramSilencerFromUpdateRate.argtypes = [ctypes.c_uint16, ctypes.c_uint16, SilencerTarget]  # type: ignore 
        self.dll.AUTDDatagramSilencerFromUpdateRate.restype = DatagramPtr

        self.dll.AUTDDatagramSilencerFixedUpdateRateIsValid.argtypes = [ctypes.c_uint16, ctypes.c_uint16, SamplingConfig, SamplingConfig]  # type: ignore 
        self.dll.AUTDDatagramSilencerFixedUpdateRateIsValid.restype = ctypes.c_bool

        self.dll.AUTDDatagramSilencerFromCompletionTime.argtypes = [Duration, Duration, ctypes.c_bool, SilencerTarget]  # type: ignore 
        self.dll.AUTDDatagramSilencerFromCompletionTime.restype = DatagramPtr

        self.dll.AUTDDatagramSilencerFixedCompletionTimeIsValid.argtypes = [Duration, Duration, ctypes.c_bool, SamplingConfig, SamplingConfig]  # type: ignore 
        self.dll.AUTDDatagramSilencerFixedCompletionTimeIsValid.restype = ctypes.c_bool

        self.dll.AUTDDatagramSilencerFixedCompletionTimeIsDefault.argtypes = [Duration, Duration, ctypes.c_bool, SilencerTarget]  # type: ignore 
        self.dll.AUTDDatagramSilencerFixedCompletionTimeIsDefault.restype = ctypes.c_bool

        self.dll.AUTDSTMFoci.argtypes = [SamplingConfig, ctypes.c_void_p, ctypes.c_uint16, ctypes.c_uint8, LoopBehavior]  # type: ignore 
        self.dll.AUTDSTMFoci.restype = ResultFociSTM

        self.dll.AUTDSTMFociIntoDatagramWithSegment.argtypes = [FociSTMPtr, ctypes.c_uint8, Segment, TransitionModeWrap]  # type: ignore 
        self.dll.AUTDSTMFociIntoDatagramWithSegment.restype = DatagramPtr

        self.dll.AUTDSTMFociIntoDatagram.argtypes = [FociSTMPtr, ctypes.c_uint8]  # type: ignore 
        self.dll.AUTDSTMFociIntoDatagram.restype = DatagramPtr

        self.dll.AUTDSTMGain.argtypes = [SamplingConfig, ctypes.POINTER(GainPtr), ctypes.c_uint16, GainSTMMode, LoopBehavior]  # type: ignore 
        self.dll.AUTDSTMGain.restype = ResultGainSTM

        self.dll.AUTDSTMGainIntoDatagramWithSegment.argtypes = [GainSTMPtr, Segment, TransitionModeWrap]  # type: ignore 
        self.dll.AUTDSTMGainIntoDatagramWithSegment.restype = DatagramPtr

        self.dll.AUTDSTMGainIntoDatagram.argtypes = [GainSTMPtr]  # type: ignore 
        self.dll.AUTDSTMGainIntoDatagram.restype = DatagramPtr

        self.dll.AUTDSTMConfigFromFreq.argtypes = [ctypes.c_float, ctypes.c_uint16] 
        self.dll.AUTDSTMConfigFromFreq.restype = ResultSamplingConfig

        self.dll.AUTDSTMConfigFromPeriod.argtypes = [Duration, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDSTMConfigFromPeriod.restype = ResultSamplingConfig

        self.dll.AUTDSTMConfigFromFreqNearest.argtypes = [ctypes.c_float, ctypes.c_uint16] 
        self.dll.AUTDSTMConfigFromFreqNearest.restype = ResultSamplingConfig

        self.dll.AUTDSTMConfigFromPeriodNearest.argtypes = [Duration, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDSTMConfigFromPeriodNearest.restype = ResultSamplingConfig

        self.dll.AUTDSTMFreq.argtypes = [SamplingConfig, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDSTMFreq.restype = ctypes.c_float

        self.dll.AUTDSTMPeriod.argtypes = [SamplingConfig, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDSTMPeriod.restype = Duration

        self.dll.AUTDDatagramSynchronize.argtypes = [] 
        self.dll.AUTDDatagramSynchronize.restype = DatagramPtr

        self.dll.AUTDDatagramWithParallelThreshold.argtypes = [DatagramPtr, ctypes.c_int32]  # type: ignore 
        self.dll.AUTDDatagramWithParallelThreshold.restype = DatagramPtr

        self.dll.AUTDDatagramWithTimeout.argtypes = [DatagramPtr, OptionDuration]  # type: ignore 
        self.dll.AUTDDatagramWithTimeout.restype = DatagramPtr

        self.dll.AUTDDcSysTimeNow.argtypes = [] 
        self.dll.AUTDDcSysTimeNow.restype = DcSysTime

        self.dll.AUTDDebugTypeNone.argtypes = [] 
        self.dll.AUTDDebugTypeNone.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeBaseSignal.argtypes = [] 
        self.dll.AUTDDebugTypeBaseSignal.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeThermo.argtypes = [] 
        self.dll.AUTDDebugTypeThermo.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeForceFan.argtypes = [] 
        self.dll.AUTDDebugTypeForceFan.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeSync.argtypes = [] 
        self.dll.AUTDDebugTypeSync.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeModSegment.argtypes = [] 
        self.dll.AUTDDebugTypeModSegment.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeModIdx.argtypes = [ctypes.c_uint16] 
        self.dll.AUTDDebugTypeModIdx.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeStmSegment.argtypes = [] 
        self.dll.AUTDDebugTypeStmSegment.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeStmIdx.argtypes = [ctypes.c_uint16] 
        self.dll.AUTDDebugTypeStmIdx.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeIsStmMode.argtypes = [] 
        self.dll.AUTDDebugTypeIsStmMode.restype = DebugTypeWrap

        self.dll.AUTDDebugTypePwmOut.argtypes = [TransducerPtr]  # type: ignore 
        self.dll.AUTDDebugTypePwmOut.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeDirect.argtypes = [ctypes.c_bool] 
        self.dll.AUTDDebugTypeDirect.restype = DebugTypeWrap

        self.dll.AUTDDebugTypeSysTimeEq.argtypes = [DcSysTime]  # type: ignore 
        self.dll.AUTDDebugTypeSysTimeEq.restype = DebugTypeWrap

        self.dll.AUTDLoopBehaviorInfinite.argtypes = [] 
        self.dll.AUTDLoopBehaviorInfinite.restype = LoopBehavior

        self.dll.AUTDLoopBehaviorFinite.argtypes = [ctypes.c_uint16] 
        self.dll.AUTDLoopBehaviorFinite.restype = LoopBehavior

        self.dll.AUTDLoopBehaviorOnce.argtypes = [] 
        self.dll.AUTDLoopBehaviorOnce.restype = LoopBehavior

        self.dll.AUTDPhaseFromRad.argtypes = [ctypes.c_float] 
        self.dll.AUTDPhaseFromRad.restype = ctypes.c_uint8

        self.dll.AUTDPhaseToRad.argtypes = [ctypes.c_uint8] 
        self.dll.AUTDPhaseToRad.restype = ctypes.c_float

        self.dll.AUTDSamplingConfigFromDivision.argtypes = [ctypes.c_uint16] 
        self.dll.AUTDSamplingConfigFromDivision.restype = ResultSamplingConfig

        self.dll.AUTDSamplingConfigFromFreq.argtypes = [ctypes.c_uint32] 
        self.dll.AUTDSamplingConfigFromFreq.restype = ResultSamplingConfig

        self.dll.AUTDSamplingConfigFromFreqF.argtypes = [ctypes.c_float] 
        self.dll.AUTDSamplingConfigFromFreqF.restype = ResultSamplingConfig

        self.dll.AUTDSamplingConfigFromFreqNearest.argtypes = [ctypes.c_float] 
        self.dll.AUTDSamplingConfigFromFreqNearest.restype = SamplingConfig

        self.dll.AUTDSamplingConfigFromPeriod.argtypes = [Duration]  # type: ignore 
        self.dll.AUTDSamplingConfigFromPeriod.restype = ResultSamplingConfig

        self.dll.AUTDSamplingConfigFromPeriodNearest.argtypes = [Duration]  # type: ignore 
        self.dll.AUTDSamplingConfigFromPeriodNearest.restype = SamplingConfig

        self.dll.AUTDSamplingConfigDivision.argtypes = [SamplingConfig]  # type: ignore 
        self.dll.AUTDSamplingConfigDivision.restype = ctypes.c_uint16

        self.dll.AUTDSamplingConfigFreq.argtypes = [SamplingConfig]  # type: ignore 
        self.dll.AUTDSamplingConfigFreq.restype = ctypes.c_float

        self.dll.AUTDSamplingConfigPeriod.argtypes = [SamplingConfig]  # type: ignore 
        self.dll.AUTDSamplingConfigPeriod.restype = Duration

        self.dll.AUTDTransitionModeSyncIdx.argtypes = [] 
        self.dll.AUTDTransitionModeSyncIdx.restype = TransitionModeWrap

        self.dll.AUTDTransitionModeSysTime.argtypes = [DcSysTime]  # type: ignore 
        self.dll.AUTDTransitionModeSysTime.restype = TransitionModeWrap

        self.dll.AUTDTransitionModeGPIO.argtypes = [GPIOIn]  # type: ignore 
        self.dll.AUTDTransitionModeGPIO.restype = TransitionModeWrap

        self.dll.AUTDTransitionModeExt.argtypes = [] 
        self.dll.AUTDTransitionModeExt.restype = TransitionModeWrap

        self.dll.AUTDTransitionModeImmediate.argtypes = [] 
        self.dll.AUTDTransitionModeImmediate.restype = TransitionModeWrap

        self.dll.AUTDTransitionModeNone.argtypes = [] 
        self.dll.AUTDTransitionModeNone.restype = TransitionModeWrap

        self.dll.AUTDGainBessel.argtypes = [Vector3, Vector3, ctypes.c_float, ctypes.c_uint8, ctypes.c_uint8]  # type: ignore 
        self.dll.AUTDGainBessel.restype = GainPtr

        self.dll.AUTDGainBesselIsDefault.argtypes = [ctypes.c_uint8, ctypes.c_uint8] 
        self.dll.AUTDGainBesselIsDefault.restype = ctypes.c_bool

        self.dll.AUTDGainCache.argtypes = [GainPtr]  # type: ignore 
        self.dll.AUTDGainCache.restype = GainCachePtr

        self.dll.AUTDGainCacheClone.argtypes = [GainCachePtr]  # type: ignore 
        self.dll.AUTDGainCacheClone.restype = GainPtr

        self.dll.AUTDGainCacheFree.argtypes = [GainCachePtr]  # type: ignore 
        self.dll.AUTDGainCacheFree.restype = None

        self.dll.AUTDGainCustom.argtypes = [ctypes.c_void_p, ctypes.c_void_p, GeometryPtr]  # type: ignore 
        self.dll.AUTDGainCustom.restype = GainPtr

        self.dll.AUTDGainFocus.argtypes = [Vector3, ctypes.c_uint8, ctypes.c_uint8]  # type: ignore 
        self.dll.AUTDGainFocus.restype = GainPtr

        self.dll.AUTDGainFocusIsDefault.argtypes = [ctypes.c_uint8, ctypes.c_uint8] 
        self.dll.AUTDGainFocusIsDefault.restype = ctypes.c_bool

        self.dll.AUTDGainGroupCreateMap.argtypes = [ctypes.POINTER(ctypes.c_uint16), ctypes.c_uint16] 
        self.dll.AUTDGainGroupCreateMap.restype = GroupGainMapPtr

        self.dll.AUTDGainGroupMapSet.argtypes = [GroupGainMapPtr, ctypes.c_uint16, ctypes.POINTER(ctypes.c_int32)]  # type: ignore 
        self.dll.AUTDGainGroupMapSet.restype = GroupGainMapPtr

        self.dll.AUTDGainGroup.argtypes = [GroupGainMapPtr, ctypes.POINTER(ctypes.c_int32), ctypes.POINTER(GainPtr), ctypes.c_uint32]  # type: ignore 
        self.dll.AUTDGainGroup.restype = GainPtr

        self.dll.AUTDGainIntoDatagramWithSegment.argtypes = [GainPtr, Segment, TransitionModeWrap]  # type: ignore 
        self.dll.AUTDGainIntoDatagramWithSegment.restype = DatagramPtr

        self.dll.AUTDGainIntoDatagram.argtypes = [GainPtr]  # type: ignore 
        self.dll.AUTDGainIntoDatagram.restype = DatagramPtr

        self.dll.AUTDGainNull.argtypes = [] 
        self.dll.AUTDGainNull.restype = GainPtr

        self.dll.AUTDGainPlane.argtypes = [Vector3, ctypes.c_uint8, ctypes.c_uint8]  # type: ignore 
        self.dll.AUTDGainPlane.restype = GainPtr

        self.dll.AUTDGainPlanelIsDefault.argtypes = [ctypes.c_uint8, ctypes.c_uint8] 
        self.dll.AUTDGainPlanelIsDefault.restype = ctypes.c_bool

        self.dll.AUTDGainUniform.argtypes = [ctypes.c_uint8, ctypes.c_uint8] 
        self.dll.AUTDGainUniform.restype = GainPtr

        self.dll.AUTDDevice.argtypes = [GeometryPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDDevice.restype = DevicePtr

        self.dll.AUTDDeviceNumTransducers.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceNumTransducers.restype = ctypes.c_uint32

        self.dll.AUTDDeviceGetSoundSpeed.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceGetSoundSpeed.restype = ctypes.c_float

        self.dll.AUTDDeviceSetSoundSpeed.argtypes = [GeometryPtr, ctypes.c_uint16, ctypes.c_float]  # type: ignore 
        self.dll.AUTDDeviceSetSoundSpeed.restype = None

        self.dll.AUTDDeviceSetSoundSpeedFromTemp.argtypes = [GeometryPtr, ctypes.c_uint16, ctypes.c_float, ctypes.c_float, ctypes.c_float, ctypes.c_float]  # type: ignore 
        self.dll.AUTDDeviceSetSoundSpeedFromTemp.restype = None

        self.dll.AUTDDeviceCenter.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceCenter.restype = Vector3

        self.dll.AUTDDeviceTranslate.argtypes = [GeometryPtr, ctypes.c_uint16, Vector3]  # type: ignore 
        self.dll.AUTDDeviceTranslate.restype = None

        self.dll.AUTDDeviceRotate.argtypes = [GeometryPtr, ctypes.c_uint16, Quaternion]  # type: ignore 
        self.dll.AUTDDeviceRotate.restype = None

        self.dll.AUTDDeviceAffine.argtypes = [GeometryPtr, ctypes.c_uint16, Vector3, Quaternion]  # type: ignore 
        self.dll.AUTDDeviceAffine.restype = None

        self.dll.AUTDDeviceEnableSet.argtypes = [GeometryPtr, ctypes.c_uint16, ctypes.c_bool]  # type: ignore 
        self.dll.AUTDDeviceEnableSet.restype = None

        self.dll.AUTDDeviceEnableGet.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceEnableGet.restype = ctypes.c_bool

        self.dll.AUTDDeviceWavelength.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceWavelength.restype = ctypes.c_float

        self.dll.AUTDDeviceWavenumber.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceWavenumber.restype = ctypes.c_float

        self.dll.AUTDDeviceRotation.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceRotation.restype = Quaternion

        self.dll.AUTDDeviceDirectionX.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceDirectionX.restype = Vector3

        self.dll.AUTDDeviceDirectionY.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceDirectionY.restype = Vector3

        self.dll.AUTDDeviceDirectionAxial.argtypes = [DevicePtr]  # type: ignore 
        self.dll.AUTDDeviceDirectionAxial.restype = Vector3

        self.dll.AUTDGeometry.argtypes = [ControllerPtr]  # type: ignore 
        self.dll.AUTDGeometry.restype = GeometryPtr

        self.dll.AUTDGeometryNumDevices.argtypes = [GeometryPtr]  # type: ignore 
        self.dll.AUTDGeometryNumDevices.restype = ctypes.c_uint32

        self.dll.AUTDGeometryNumTransducers.argtypes = [GeometryPtr]  # type: ignore 
        self.dll.AUTDGeometryNumTransducers.restype = ctypes.c_uint32

        self.dll.AUTDGeometrCenter.argtypes = [GeometryPtr]  # type: ignore 
        self.dll.AUTDGeometrCenter.restype = Vector3

        self.dll.AUTDRotationFromEulerXYZ.argtypes = [ctypes.c_float, ctypes.c_float, ctypes.c_float] 
        self.dll.AUTDRotationFromEulerXYZ.restype = Quaternion

        self.dll.AUTDRotationFromEulerZYZ.argtypes = [ctypes.c_float, ctypes.c_float, ctypes.c_float] 
        self.dll.AUTDRotationFromEulerZYZ.restype = Quaternion

        self.dll.AUTDTransducer.argtypes = [DevicePtr, ctypes.c_uint8]  # type: ignore 
        self.dll.AUTDTransducer.restype = TransducerPtr

        self.dll.AUTDTransducerPosition.argtypes = [TransducerPtr]  # type: ignore 
        self.dll.AUTDTransducerPosition.restype = Vector3

        self.dll.AUTDCreateRuntime.argtypes = [] 
        self.dll.AUTDCreateRuntime.restype = RuntimePtr

        self.dll.AUTDGetRuntimeHandle.argtypes = [RuntimePtr]  # type: ignore 
        self.dll.AUTDGetRuntimeHandle.restype = HandlePtr

        self.dll.AUTDDeleteRuntime.argtypes = [RuntimePtr]  # type: ignore 
        self.dll.AUTDDeleteRuntime.restype = None

        self.dll.AUTDWaitResultStatus.argtypes = [HandlePtr, FfiFuture]  # type: ignore 
        self.dll.AUTDWaitResultStatus.restype = ResultStatus

        self.dll.AUTDWaitLocalResultStatus.argtypes = [HandlePtr, LocalFfiFuture]  # type: ignore 
        self.dll.AUTDWaitLocalResultStatus.restype = ResultStatus

        self.dll.AUTDWaitResultController.argtypes = [HandlePtr, FfiFuture]  # type: ignore 
        self.dll.AUTDWaitResultController.restype = ResultController

        self.dll.AUTDWaitResultFPGAStateList.argtypes = [HandlePtr, FfiFuture]  # type: ignore 
        self.dll.AUTDWaitResultFPGAStateList.restype = ResultFPGAStateList

        self.dll.AUTDWaitResultFirmwareVersionList.argtypes = [HandlePtr, FfiFuture]  # type: ignore 
        self.dll.AUTDWaitResultFirmwareVersionList.restype = ResultFirmwareVersionList

        self.dll.AUTDTracingInit.argtypes = [] 
        self.dll.AUTDTracingInit.restype = None

        self.dll.AUTDTracingInitWithFile.argtypes = [ctypes.c_char_p] 
        self.dll.AUTDTracingInitWithFile.restype = ResultStatus

        self.dll.AUTDLinkAudit.argtypes = [] 
        self.dll.AUTDLinkAudit.restype = LinkBuilderPtr

        self.dll.AUTDLinkAuditIsOpen.argtypes = [LinkPtr]  # type: ignore 
        self.dll.AUTDLinkAuditIsOpen.restype = ctypes.c_bool

        self.dll.AUTDLinkAuditDown.argtypes = [LinkPtr]  # type: ignore 
        self.dll.AUTDLinkAuditDown.restype = None

        self.dll.AUTDLinkAuditUp.argtypes = [LinkPtr]  # type: ignore 
        self.dll.AUTDLinkAuditUp.restype = None

        self.dll.AUTDLinkAuditBreakDown.argtypes = [LinkPtr]  # type: ignore 
        self.dll.AUTDLinkAuditBreakDown.restype = None

        self.dll.AUTDLinkAuditRepair.argtypes = [LinkPtr]  # type: ignore 
        self.dll.AUTDLinkAuditRepair.restype = None

        self.dll.AUTDLinkAuditLastTimeout.argtypes = [LinkPtr]  # type: ignore 
        self.dll.AUTDLinkAuditLastTimeout.restype = OptionDuration

        self.dll.AUTDLinkAuditLastParallelThreshold.argtypes = [LinkPtr]  # type: ignore 
        self.dll.AUTDLinkAuditLastParallelThreshold.restype = ctypes.c_int64

        self.dll.AUTDLinkAuditCpuNumTransducers.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditCpuNumTransducers.restype = ctypes.c_uint32

        self.dll.AUTDLinkAuditFpgaAssertThermalSensor.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaAssertThermalSensor.restype = None

        self.dll.AUTDLinkAuditFpgaDeassertThermalSensor.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaDeassertThermalSensor.restype = None

        self.dll.AUTDLinkAuditFpgaIsForceFan.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaIsForceFan.restype = ctypes.c_bool

        self.dll.AUTDLinkAuditFpgaCurrentStmSegment.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaCurrentStmSegment.restype = Segment

        self.dll.AUTDLinkAuditFpgaCurrentModSegment.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaCurrentModSegment.restype = Segment

        self.dll.AUTDLinkAuditFpgaIsStmGainMode.argtypes = [LinkPtr, Segment, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaIsStmGainMode.restype = ctypes.c_bool

        self.dll.AUTDLinkAuditCpuSilencerStrictMode.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditCpuSilencerStrictMode.restype = ctypes.c_bool

        self.dll.AUTDLinkAuditFpgaSilencerUpdateRateIntensity.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaSilencerUpdateRateIntensity.restype = ctypes.c_uint16

        self.dll.AUTDLinkAuditFpgaSilencerUpdateRatePhase.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaSilencerUpdateRatePhase.restype = ctypes.c_uint16

        self.dll.AUTDLinkAuditFpgaSilencerCompletionStepsIntensity.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaSilencerCompletionStepsIntensity.restype = Duration

        self.dll.AUTDLinkAuditFpgaSilencerCompletionStepsPhase.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaSilencerCompletionStepsPhase.restype = Duration

        self.dll.AUTDLinkAuditFpgaSilencerFixedCompletionStepsMode.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaSilencerFixedCompletionStepsMode.restype = ctypes.c_bool

        self.dll.AUTDLinkAuditFpgaSilencerTarget.argtypes = [LinkPtr, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaSilencerTarget.restype = SilencerTarget

        self.dll.AUTDLinkAuditFpgaDebugTypes.argtypes = [LinkPtr, ctypes.c_uint16, ctypes.POINTER(ctypes.c_uint8)]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaDebugTypes.restype = None

        self.dll.AUTDLinkAuditFpgaDebugValues.argtypes = [LinkPtr, ctypes.c_uint16, ctypes.POINTER(ctypes.c_uint64)]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaDebugValues.restype = None

        self.dll.AUTDLinkAuditFpgaStmFreqDivision.argtypes = [LinkPtr, Segment, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaStmFreqDivision.restype = ctypes.c_uint16

        self.dll.AUTDLinkAuditFpgaStmCycle.argtypes = [LinkPtr, Segment, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaStmCycle.restype = ctypes.c_uint16

        self.dll.AUTDLinkAuditFpgaSoundSpeed.argtypes = [LinkPtr, Segment, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaSoundSpeed.restype = ctypes.c_uint16

        self.dll.AUTDLinkAuditFpgaStmLoopBehavior.argtypes = [LinkPtr, Segment, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaStmLoopBehavior.restype = LoopBehavior

        self.dll.AUTDLinkAuditFpgaModulationFreqDivision.argtypes = [LinkPtr, Segment, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaModulationFreqDivision.restype = ctypes.c_uint16

        self.dll.AUTDLinkAuditFpgaModulationCycle.argtypes = [LinkPtr, Segment, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaModulationCycle.restype = ctypes.c_uint16

        self.dll.AUTDLinkAuditFpgaModulationBuffer.argtypes = [LinkPtr, Segment, ctypes.c_uint16, ctypes.POINTER(ctypes.c_uint8), ctypes.c_uint32]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaModulationBuffer.restype = None

        self.dll.AUTDLinkAuditFpgaModulationLoopBehavior.argtypes = [LinkPtr, Segment, ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaModulationLoopBehavior.restype = LoopBehavior

        self.dll.AUTDLinkAuditFpgaDrivesAt.argtypes = [LinkPtr, Segment, ctypes.c_uint16, ctypes.c_uint16, ctypes.POINTER(Drive)]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaDrivesAt.restype = None

        self.dll.AUTDLinkAuditFpgaPulseWidthEncoderTable.argtypes = [LinkPtr, ctypes.c_uint16, ctypes.POINTER(ctypes.c_uint8)]  # type: ignore 
        self.dll.AUTDLinkAuditFpgaPulseWidthEncoderTable.restype = None

        self.dll.AUTDLinkGet.argtypes = [ControllerPtr]  # type: ignore 
        self.dll.AUTDLinkGet.restype = LinkPtr

        self.dll.AUTDLinkNop.argtypes = [] 
        self.dll.AUTDLinkNop.restype = LinkBuilderPtr

        self.dll.AUTDModulationCache.argtypes = [ModulationPtr]  # type: ignore 
        self.dll.AUTDModulationCache.restype = ModulationCachePtr

        self.dll.AUTDModulationCacheClone.argtypes = [ModulationCachePtr, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationCacheClone.restype = ModulationPtr

        self.dll.AUTDModulationCacheFree.argtypes = [ModulationCachePtr]  # type: ignore 
        self.dll.AUTDModulationCacheFree.restype = None

        self.dll.AUTDModulationCustom.argtypes = [SamplingConfig, LoopBehavior, ctypes.POINTER(ctypes.c_uint8), ctypes.c_uint16]  # type: ignore 
        self.dll.AUTDModulationCustom.restype = ModulationPtr

        self.dll.AUTDModulationCustomWithResample.argtypes = [LoopBehavior, ctypes.POINTER(ctypes.c_uint8), ctypes.c_uint16, ctypes.c_float, SamplingConfig, DynSincInterpolator]  # type: ignore 
        self.dll.AUTDModulationCustomWithResample.restype = ModulationPtr

        self.dll.AUTDModulationWithFir.argtypes = [ModulationPtr, LoopBehavior, ctypes.POINTER(ctypes.c_float), ctypes.c_uint32]  # type: ignore 
        self.dll.AUTDModulationWithFir.restype = ModulationPtr

        self.dll.AUTDModulationFourierExact.argtypes = [ctypes.POINTER(ctypes.c_uint32), ctypes.POINTER(SamplingConfig), ctypes.POINTER(ctypes.c_uint8), ctypes.POINTER(ctypes.c_uint8), ctypes.POINTER(ctypes.c_float), ctypes.POINTER(ctypes.c_bool), ctypes.c_uint32, ctypes.c_bool, ctypes.c_float, ctypes.c_uint8, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationFourierExact.restype = ResultModulation

        self.dll.AUTDModulationFourierExactFloat.argtypes = [ctypes.POINTER(ctypes.c_float), ctypes.POINTER(SamplingConfig), ctypes.POINTER(ctypes.c_uint8), ctypes.POINTER(ctypes.c_uint8), ctypes.POINTER(ctypes.c_float), ctypes.POINTER(ctypes.c_bool), ctypes.c_uint32, ctypes.c_bool, ctypes.c_float, ctypes.c_uint8, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationFourierExactFloat.restype = ResultModulation

        self.dll.AUTDModulationFourierNearest.argtypes = [ctypes.POINTER(ctypes.c_float), ctypes.POINTER(SamplingConfig), ctypes.POINTER(ctypes.c_uint8), ctypes.POINTER(ctypes.c_uint8), ctypes.POINTER(ctypes.c_float), ctypes.POINTER(ctypes.c_bool), ctypes.c_uint32, ctypes.c_bool, ctypes.c_float, ctypes.c_uint8, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationFourierNearest.restype = ResultModulation

        self.dll.AUTDModulationSamplingConfig.argtypes = [ModulationPtr]  # type: ignore 
        self.dll.AUTDModulationSamplingConfig.restype = SamplingConfig

        self.dll.AUTDModulationIntoDatagramWithSegment.argtypes = [ModulationPtr, Segment, TransitionModeWrap]  # type: ignore 
        self.dll.AUTDModulationIntoDatagramWithSegment.restype = DatagramPtr

        self.dll.AUTDModulationIntoDatagram.argtypes = [ModulationPtr]  # type: ignore 
        self.dll.AUTDModulationIntoDatagram.restype = DatagramPtr

        self.dll.AUTDModulationWithRadiationPressure.argtypes = [ModulationPtr, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationWithRadiationPressure.restype = ModulationPtr

        self.dll.AUTDModulationSineExact.argtypes = [ctypes.c_uint32, SamplingConfig, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_float, ctypes.c_bool, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationSineExact.restype = ResultModulation

        self.dll.AUTDModulationSineExactFloat.argtypes = [ctypes.c_float, SamplingConfig, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_float, ctypes.c_bool, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationSineExactFloat.restype = ResultModulation

        self.dll.AUTDModulationSineNearest.argtypes = [ctypes.c_float, SamplingConfig, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_float, ctypes.c_bool, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationSineNearest.restype = ResultModulation

        self.dll.AUTDModulationSineExactFreq.argtypes = [ctypes.c_uint32] 
        self.dll.AUTDModulationSineExactFreq.restype = ctypes.c_uint32

        self.dll.AUTDModulationSineExactFloatFreq.argtypes = [ctypes.c_float] 
        self.dll.AUTDModulationSineExactFloatFreq.restype = ctypes.c_float

        self.dll.AUTDModulationSineNearestFreq.argtypes = [ctypes.c_float] 
        self.dll.AUTDModulationSineNearestFreq.restype = ctypes.c_float

        self.dll.AUTDModulationSineIsDefault.argtypes = [SamplingConfig, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_float, ctypes.c_bool, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationSineIsDefault.restype = ctypes.c_bool

        self.dll.AUTDModulationSquareExact.argtypes = [ctypes.c_uint32, SamplingConfig, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_float, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationSquareExact.restype = ResultModulation

        self.dll.AUTDModulationSquareExactFloat.argtypes = [ctypes.c_float, SamplingConfig, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_float, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationSquareExactFloat.restype = ResultModulation

        self.dll.AUTDModulationSquareNearest.argtypes = [ctypes.c_float, SamplingConfig, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_float, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationSquareNearest.restype = ResultModulation

        self.dll.AUTDModulationSquareExactFreq.argtypes = [ctypes.c_uint32] 
        self.dll.AUTDModulationSquareExactFreq.restype = ctypes.c_uint32

        self.dll.AUTDModulationSquareExactFloatFreq.argtypes = [ctypes.c_float] 
        self.dll.AUTDModulationSquareExactFloatFreq.restype = ctypes.c_float

        self.dll.AUTDModulationSquareNearestFreq.argtypes = [ctypes.c_float] 
        self.dll.AUTDModulationSquareNearestFreq.restype = ctypes.c_float

        self.dll.AUTDModulationSquareIsDefault.argtypes = [SamplingConfig, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_float, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationSquareIsDefault.restype = ctypes.c_bool

        self.dll.AUTDModulationStatic.argtypes = [ctypes.c_uint8, LoopBehavior]  # type: ignore 
        self.dll.AUTDModulationStatic.restype = ModulationPtr

        self.dll.AUTDModulationStaticIsDefault.argtypes = [ctypes.c_uint8] 
        self.dll.AUTDModulationStaticIsDefault.restype = ctypes.c_bool

        self.dll.AUTDGetErr.argtypes = [ctypes.c_void_p, ctypes.c_char_p] 
        self.dll.AUTDGetErr.restype = None

    def controller_builder(self, pos: ctypes.Array | None, rot: ctypes.Array | None, len: int, fallback_parallel_threshold: int, fallback_timeout: Duration, send_interval: Duration, receive_interval: Duration, timer_strategy: TimerStrategyWrap) -> ControllerBuilderPtr:
        return self.dll.AUTDControllerBuilder(pos, rot, len, fallback_parallel_threshold, fallback_timeout, send_interval, receive_interval, timer_strategy)

    def controller_builder_is_default(self, fallback_parallel_threshold: int, fallback_timeout: Duration, send_interval_ns: Duration, receive_interval: Duration, timer_strategy: TimerStrategyWrap) -> ctypes.c_bool:
        return self.dll.AUTDControllerBuilderIsDefault(fallback_parallel_threshold, fallback_timeout, send_interval_ns, receive_interval, timer_strategy)

    def controller_open(self, builder: ControllerBuilderPtr, link_builder: LinkBuilderPtr, timeout: OptionDuration) -> FfiFuture:
        return self.dll.AUTDControllerOpen(builder, link_builder, timeout)

    def controller_group(self, cnt: ControllerPtr, f: ctypes.c_void_p | None, context: ctypes.c_void_p | None, geometry: GeometryPtr, keys: ctypes.Array[ctypes.c_int32] | None, d: ctypes.Array | None, n: int) -> LocalFfiFuture:
        return self.dll.AUTDControllerGroup(cnt, f, context, geometry, keys, d, n)

    def controller_close(self, cnt: ControllerPtr) -> FfiFuture:
        return self.dll.AUTDControllerClose(cnt)

    def controller_fpga_state(self, cnt: ControllerPtr) -> FfiFuture:
        return self.dll.AUTDControllerFPGAState(cnt)

    def controller_fpga_state_get(self, p: FPGAStateListPtr, idx: int) -> ctypes.c_int16:
        return self.dll.AUTDControllerFPGAStateGet(p, idx)

    def controller_fpga_state_delete(self, p: FPGAStateListPtr) -> None:
        return self.dll.AUTDControllerFPGAStateDelete(p)

    def controller_firmware_version_list_pointer(self, cnt: ControllerPtr) -> FfiFuture:
        return self.dll.AUTDControllerFirmwareVersionListPointer(cnt)

    def controller_firmware_version_get(self, p_info_list: FirmwareVersionListPtr, idx: int, info: ctypes.Array[ctypes.c_char] | None) -> None:
        return self.dll.AUTDControllerFirmwareVersionGet(p_info_list, idx, info)

    def controller_firmware_version_list_pointer_delete(self, p_info_list: FirmwareVersionListPtr) -> None:
        return self.dll.AUTDControllerFirmwareVersionListPointerDelete(p_info_list)

    def firmware_latest(self, latest: ctypes.Array[ctypes.c_char] | None) -> None:
        return self.dll.AUTDFirmwareLatest(latest)

    def controller_send(self, cnt: ControllerPtr, d: DatagramPtr) -> FfiFuture:
        return self.dll.AUTDControllerSend(cnt, d)

    def timer_strategy_std(self, timer_resolution: int) -> TimerStrategyWrap:
        return self.dll.AUTDTimerStrategyStd(timer_resolution)

    def timer_strategy_spin_default_accuracy(self) -> ctypes.c_uint32:
        return self.dll.AUTDTimerStrategySpinDefaultAccuracy()

    def timer_strategy_spin(self, native_accuracy_ns: int, spin_strategy: SpinStrategyTag) -> TimerStrategyWrap:
        return self.dll.AUTDTimerStrategySpin(native_accuracy_ns, spin_strategy)

    def timer_strategy_async(self, timer_resolution: int) -> TimerStrategyWrap:
        return self.dll.AUTDTimerStrategyAsync(timer_resolution)

    def timer_strategy_waitable(self) -> TimerStrategyWrap:
        return self.dll.AUTDTimerStrategyWaitable()

    def datagram_clear(self) -> DatagramPtr:
        return self.dll.AUTDDatagramClear()

    def datagram_debug_settings(self, f: ctypes.c_void_p | None, context: ctypes.c_void_p | None, geometry: GeometryPtr) -> DatagramPtr:
        return self.dll.AUTDDatagramDebugSettings(f, context, geometry)

    def datagram_force_fan(self, f: ctypes.c_void_p | None, context: ctypes.c_void_p | None, geometry: GeometryPtr) -> DatagramPtr:
        return self.dll.AUTDDatagramForceFan(f, context, geometry)

    def datagram_tuple(self, d1: DatagramPtr, d2: DatagramPtr) -> DatagramPtr:
        return self.dll.AUTDDatagramTuple(d1, d2)

    def datagram_phase_corr(self, f: ctypes.c_void_p | None, context: ctypes.c_void_p | None, geometry: GeometryPtr) -> DatagramPtr:
        return self.dll.AUTDDatagramPhaseCorr(f, context, geometry)

    def datagram_pulse_width_encoder(self, f: ctypes.c_void_p | None, context: ctypes.c_void_p | None, geometry: GeometryPtr) -> DatagramPtr:
        return self.dll.AUTDDatagramPulseWidthEncoder(f, context, geometry)

    def datagram_pulse_width_encoder_default(self) -> DatagramPtr:
        return self.dll.AUTDDatagramPulseWidthEncoderDefault()

    def datagram_reads_fpga_state(self, f: ctypes.c_void_p | None, context: ctypes.c_void_p | None, geometry: GeometryPtr) -> DatagramPtr:
        return self.dll.AUTDDatagramReadsFPGAState(f, context, geometry)

    def datagram_swap_segment_modulation(self, segment: Segment, transition_mode: TransitionModeWrap) -> DatagramPtr:
        return self.dll.AUTDDatagramSwapSegmentModulation(segment, transition_mode)

    def datagram_swap_segment_foci_stm(self, segment: Segment, transition_mode: TransitionModeWrap) -> DatagramPtr:
        return self.dll.AUTDDatagramSwapSegmentFociSTM(segment, transition_mode)

    def datagram_swap_segment_gain_stm(self, segment: Segment, transition_mode: TransitionModeWrap) -> DatagramPtr:
        return self.dll.AUTDDatagramSwapSegmentGainSTM(segment, transition_mode)

    def datagram_swap_segment_gain(self, segment: Segment, transition_mode: TransitionModeWrap) -> DatagramPtr:
        return self.dll.AUTDDatagramSwapSegmentGain(segment, transition_mode)

    def datagram_silencer_from_update_rate(self, intensity: int, phase: int, target: SilencerTarget) -> DatagramPtr:
        return self.dll.AUTDDatagramSilencerFromUpdateRate(intensity, phase, target)

    def datagram_silencer_fixed_update_rate_is_valid(self, intensity: int, phase: int, config_intensity: SamplingConfig, config_phase: SamplingConfig) -> ctypes.c_bool:
        return self.dll.AUTDDatagramSilencerFixedUpdateRateIsValid(intensity, phase, config_intensity, config_phase)

    def datagram_silencer_from_completion_time(self, intensity: Duration, phase: Duration, strict_mode: bool, target: SilencerTarget) -> DatagramPtr:
        return self.dll.AUTDDatagramSilencerFromCompletionTime(intensity, phase, strict_mode, target)

    def datagram_silencer_fixed_completion_time_is_valid(self, intensity: Duration, phase: Duration, strict_mode: bool, config_intensity: SamplingConfig, config_phase: SamplingConfig) -> ctypes.c_bool:
        return self.dll.AUTDDatagramSilencerFixedCompletionTimeIsValid(intensity, phase, strict_mode, config_intensity, config_phase)

    def datagram_silencer_fixed_completion_time_is_default(self, intensity: Duration, phase: Duration, strict_mode: bool, target: SilencerTarget) -> ctypes.c_bool:
        return self.dll.AUTDDatagramSilencerFixedCompletionTimeIsDefault(intensity, phase, strict_mode, target)

    def stm_foci(self, config: SamplingConfig, points: ctypes.c_void_p | None, size: int, n: int, loop_behavior: LoopBehavior) -> ResultFociSTM:
        return self.dll.AUTDSTMFoci(config, points, size, n, loop_behavior)

    def stm_foci_into_datagram_with_segment(self, stm: FociSTMPtr, n: int, segment: Segment, transition_mode: TransitionModeWrap) -> DatagramPtr:
        return self.dll.AUTDSTMFociIntoDatagramWithSegment(stm, n, segment, transition_mode)

    def stm_foci_into_datagram(self, stm: FociSTMPtr, n: int) -> DatagramPtr:
        return self.dll.AUTDSTMFociIntoDatagram(stm, n)

    def stm_gain(self, config: SamplingConfig, gains: ctypes.Array | None, size: int, mode: GainSTMMode, loop_behavior: LoopBehavior) -> ResultGainSTM:
        return self.dll.AUTDSTMGain(config, gains, size, mode, loop_behavior)

    def stm_gain_into_datagram_with_segment(self, stm: GainSTMPtr, segment: Segment, transition_mode: TransitionModeWrap) -> DatagramPtr:
        return self.dll.AUTDSTMGainIntoDatagramWithSegment(stm, segment, transition_mode)

    def stm_gain_into_datagram(self, stm: GainSTMPtr) -> DatagramPtr:
        return self.dll.AUTDSTMGainIntoDatagram(stm)

    def stm_config_from_freq(self, f: float, n: int) -> ResultSamplingConfig:
        return self.dll.AUTDSTMConfigFromFreq(f, n)

    def stm_config_from_period(self, p: Duration, n: int) -> ResultSamplingConfig:
        return self.dll.AUTDSTMConfigFromPeriod(p, n)

    def stm_config_from_freq_nearest(self, f: float, n: int) -> ResultSamplingConfig:
        return self.dll.AUTDSTMConfigFromFreqNearest(f, n)

    def stm_config_from_period_nearest(self, p: Duration, n: int) -> ResultSamplingConfig:
        return self.dll.AUTDSTMConfigFromPeriodNearest(p, n)

    def stm_freq(self, c: SamplingConfig, n: int) -> ctypes.c_float:
        return self.dll.AUTDSTMFreq(c, n)

    def stm_period(self, c: SamplingConfig, n: int) -> Duration:
        return self.dll.AUTDSTMPeriod(c, n)

    def datagram_synchronize(self) -> DatagramPtr:
        return self.dll.AUTDDatagramSynchronize()

    def datagram_with_parallel_threshold(self, d: DatagramPtr, threshold: int) -> DatagramPtr:
        return self.dll.AUTDDatagramWithParallelThreshold(d, threshold)

    def datagram_with_timeout(self, d: DatagramPtr, timeout: OptionDuration) -> DatagramPtr:
        return self.dll.AUTDDatagramWithTimeout(d, timeout)

    def dc_sys_time_now(self) -> DcSysTime:
        return self.dll.AUTDDcSysTimeNow()

    def debug_type_none(self) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeNone()

    def debug_type_base_signal(self) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeBaseSignal()

    def debug_type_thermo(self) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeThermo()

    def debug_type_force_fan(self) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeForceFan()

    def debug_type_sync(self) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeSync()

    def debug_type_mod_segment(self) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeModSegment()

    def debug_type_mod_idx(self, value: int) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeModIdx(value)

    def debug_type_stm_segment(self) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeStmSegment()

    def debug_type_stm_idx(self, value: int) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeStmIdx(value)

    def debug_type_is_stm_mode(self) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeIsStmMode()

    def debug_type_pwm_out(self, value: TransducerPtr) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypePwmOut(value)

    def debug_type_direct(self, value: bool) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeDirect(value)

    def debug_type_sys_time_eq(self, sys_time: DcSysTime) -> DebugTypeWrap:
        return self.dll.AUTDDebugTypeSysTimeEq(sys_time)

    def loop_behavior_infinite(self) -> LoopBehavior:
        return self.dll.AUTDLoopBehaviorInfinite()

    def loop_behavior_finite(self, v: int) -> LoopBehavior:
        return self.dll.AUTDLoopBehaviorFinite(v)

    def loop_behavior_once(self) -> LoopBehavior:
        return self.dll.AUTDLoopBehaviorOnce()

    def phase_from_rad(self, value: float) -> ctypes.c_uint8:
        return self.dll.AUTDPhaseFromRad(value)

    def phase_to_rad(self, value: int) -> ctypes.c_float:
        return self.dll.AUTDPhaseToRad(value)

    def sampling_config_from_division(self, div: int) -> ResultSamplingConfig:
        return self.dll.AUTDSamplingConfigFromDivision(div)

    def sampling_config_from_freq(self, f: int) -> ResultSamplingConfig:
        return self.dll.AUTDSamplingConfigFromFreq(f)

    def sampling_config_from_freq_f(self, f: float) -> ResultSamplingConfig:
        return self.dll.AUTDSamplingConfigFromFreqF(f)

    def sampling_config_from_freq_nearest(self, f: float) -> SamplingConfig:
        return self.dll.AUTDSamplingConfigFromFreqNearest(f)

    def sampling_config_from_period(self, p: Duration) -> ResultSamplingConfig:
        return self.dll.AUTDSamplingConfigFromPeriod(p)

    def sampling_config_from_period_nearest(self, p: Duration) -> SamplingConfig:
        return self.dll.AUTDSamplingConfigFromPeriodNearest(p)

    def sampling_config_division(self, c: SamplingConfig) -> ctypes.c_uint16:
        return self.dll.AUTDSamplingConfigDivision(c)

    def sampling_config_freq(self, c: SamplingConfig) -> ctypes.c_float:
        return self.dll.AUTDSamplingConfigFreq(c)

    def sampling_config_period(self, c: SamplingConfig) -> Duration:
        return self.dll.AUTDSamplingConfigPeriod(c)

    def transition_mode_sync_idx(self) -> TransitionModeWrap:
        return self.dll.AUTDTransitionModeSyncIdx()

    def transition_mode_sys_time(self, sys_time: DcSysTime) -> TransitionModeWrap:
        return self.dll.AUTDTransitionModeSysTime(sys_time)

    def transition_mode_gpio(self, gpio: GPIOIn) -> TransitionModeWrap:
        return self.dll.AUTDTransitionModeGPIO(gpio)

    def transition_mode_ext(self) -> TransitionModeWrap:
        return self.dll.AUTDTransitionModeExt()

    def transition_mode_immediate(self) -> TransitionModeWrap:
        return self.dll.AUTDTransitionModeImmediate()

    def transition_mode_none(self) -> TransitionModeWrap:
        return self.dll.AUTDTransitionModeNone()

    def gain_bessel(self, p: Vector3, n: Vector3, theta_z: float, intensity: int, phase_offset: int) -> GainPtr:
        return self.dll.AUTDGainBessel(p, n, theta_z, intensity, phase_offset)

    def gain_bessel_is_default(self, intensity: int, phase_offset: int) -> ctypes.c_bool:
        return self.dll.AUTDGainBesselIsDefault(intensity, phase_offset)

    def gain_cache(self, g: GainPtr) -> GainCachePtr:
        return self.dll.AUTDGainCache(g)

    def gain_cache_clone(self, g: GainCachePtr) -> GainPtr:
        return self.dll.AUTDGainCacheClone(g)

    def gain_cache_free(self, g: GainCachePtr) -> None:
        return self.dll.AUTDGainCacheFree(g)

    def gain_custom(self, f: ctypes.c_void_p | None, context: ctypes.c_void_p | None, geometry: GeometryPtr) -> GainPtr:
        return self.dll.AUTDGainCustom(f, context, geometry)

    def gain_focus(self, p: Vector3, intensity: int, phase_offset: int) -> GainPtr:
        return self.dll.AUTDGainFocus(p, intensity, phase_offset)

    def gain_focus_is_default(self, intensity: int, phase_offset: int) -> ctypes.c_bool:
        return self.dll.AUTDGainFocusIsDefault(intensity, phase_offset)

    def gain_group_create_map(self, device_indices_ptr: ctypes.Array[ctypes.c_uint16] | None, num_devices: int) -> GroupGainMapPtr:
        return self.dll.AUTDGainGroupCreateMap(device_indices_ptr, num_devices)

    def gain_group_map_set(self, map: GroupGainMapPtr, dev_idx: int, map_data: ctypes.Array[ctypes.c_int32] | None) -> GroupGainMapPtr:
        return self.dll.AUTDGainGroupMapSet(map, dev_idx, map_data)

    def gain_group(self, map: GroupGainMapPtr, keys_ptr: ctypes.Array[ctypes.c_int32] | None, values_ptr: ctypes.Array | None, kv_len: int) -> GainPtr:
        return self.dll.AUTDGainGroup(map, keys_ptr, values_ptr, kv_len)

    def gain_into_datagram_with_segment(self, gain: GainPtr, segment: Segment, transition_mode: TransitionModeWrap) -> DatagramPtr:
        return self.dll.AUTDGainIntoDatagramWithSegment(gain, segment, transition_mode)

    def gain_into_datagram(self, gain: GainPtr) -> DatagramPtr:
        return self.dll.AUTDGainIntoDatagram(gain)

    def gain_null(self) -> GainPtr:
        return self.dll.AUTDGainNull()

    def gain_plane(self, n: Vector3, intensity: int, phase_offset: int) -> GainPtr:
        return self.dll.AUTDGainPlane(n, intensity, phase_offset)

    def gain_planel_is_default(self, intensity: int, phase_offset: int) -> ctypes.c_bool:
        return self.dll.AUTDGainPlanelIsDefault(intensity, phase_offset)

    def gain_uniform(self, intensity: int, phase: int) -> GainPtr:
        return self.dll.AUTDGainUniform(intensity, phase)

    def device(self, geo: GeometryPtr, dev_idx: int) -> DevicePtr:
        return self.dll.AUTDDevice(geo, dev_idx)

    def device_num_transducers(self, dev: DevicePtr) -> ctypes.c_uint32:
        return self.dll.AUTDDeviceNumTransducers(dev)

    def device_get_sound_speed(self, dev: DevicePtr) -> ctypes.c_float:
        return self.dll.AUTDDeviceGetSoundSpeed(dev)

    def device_set_sound_speed(self, geo: GeometryPtr, dev_idx: int, value: float) -> None:
        return self.dll.AUTDDeviceSetSoundSpeed(geo, dev_idx, value)

    def device_set_sound_speed_from_temp(self, geo: GeometryPtr, dev_idx: int, temp: float, k: float, r: float, m: float) -> None:
        return self.dll.AUTDDeviceSetSoundSpeedFromTemp(geo, dev_idx, temp, k, r, m)

    def device_center(self, dev: DevicePtr) -> Vector3:
        return self.dll.AUTDDeviceCenter(dev)

    def device_translate(self, geo: GeometryPtr, dev_idx: int, t: Vector3) -> None:
        return self.dll.AUTDDeviceTranslate(geo, dev_idx, t)

    def device_rotate(self, geo: GeometryPtr, dev_idx: int, r: Quaternion) -> None:
        return self.dll.AUTDDeviceRotate(geo, dev_idx, r)

    def device_affine(self, geo: GeometryPtr, dev_idx: int, t: Vector3, r: Quaternion) -> None:
        return self.dll.AUTDDeviceAffine(geo, dev_idx, t, r)

    def device_enable_set(self, geo: GeometryPtr, dev_idx: int, value: bool) -> None:
        return self.dll.AUTDDeviceEnableSet(geo, dev_idx, value)

    def device_enable_get(self, dev: DevicePtr) -> ctypes.c_bool:
        return self.dll.AUTDDeviceEnableGet(dev)

    def device_wavelength(self, dev: DevicePtr) -> ctypes.c_float:
        return self.dll.AUTDDeviceWavelength(dev)

    def device_wavenumber(self, dev: DevicePtr) -> ctypes.c_float:
        return self.dll.AUTDDeviceWavenumber(dev)

    def device_rotation(self, dev: DevicePtr) -> Quaternion:
        return self.dll.AUTDDeviceRotation(dev)

    def device_direction_x(self, dev: DevicePtr) -> Vector3:
        return self.dll.AUTDDeviceDirectionX(dev)

    def device_direction_y(self, dev: DevicePtr) -> Vector3:
        return self.dll.AUTDDeviceDirectionY(dev)

    def device_direction_axial(self, dev: DevicePtr) -> Vector3:
        return self.dll.AUTDDeviceDirectionAxial(dev)

    def geometry(self, cnt: ControllerPtr) -> GeometryPtr:
        return self.dll.AUTDGeometry(cnt)

    def geometry_num_devices(self, geo: GeometryPtr) -> ctypes.c_uint32:
        return self.dll.AUTDGeometryNumDevices(geo)

    def geometry_num_transducers(self, geo: GeometryPtr) -> ctypes.c_uint32:
        return self.dll.AUTDGeometryNumTransducers(geo)

    def geometr_center(self, geo: GeometryPtr) -> Vector3:
        return self.dll.AUTDGeometrCenter(geo)

    def rotation_from_euler_xyz(self, x: float, y: float, z: float) -> Quaternion:
        return self.dll.AUTDRotationFromEulerXYZ(x, y, z)

    def rotation_from_euler_zyz(self, z1: float, y: float, z2: float) -> Quaternion:
        return self.dll.AUTDRotationFromEulerZYZ(z1, y, z2)

    def transducer(self, dev: DevicePtr, idx: int) -> TransducerPtr:
        return self.dll.AUTDTransducer(dev, idx)

    def transducer_position(self, tr: TransducerPtr) -> Vector3:
        return self.dll.AUTDTransducerPosition(tr)

    def create_runtime(self) -> RuntimePtr:
        return self.dll.AUTDCreateRuntime()

    def get_runtime_handle(self, runtime: RuntimePtr) -> HandlePtr:
        return self.dll.AUTDGetRuntimeHandle(runtime)

    def delete_runtime(self, runtime: RuntimePtr) -> None:
        return self.dll.AUTDDeleteRuntime(runtime)

    def wait_result_status(self, handle: HandlePtr, future: FfiFuture) -> ResultStatus:
        return self.dll.AUTDWaitResultStatus(handle, future)

    def wait_local_result_status(self, handle: HandlePtr, future: LocalFfiFuture) -> ResultStatus:
        return self.dll.AUTDWaitLocalResultStatus(handle, future)

    def wait_result_controller(self, handle: HandlePtr, future: FfiFuture) -> ResultController:
        return self.dll.AUTDWaitResultController(handle, future)

    def wait_result_fpga_state_list(self, handle: HandlePtr, future: FfiFuture) -> ResultFPGAStateList:
        return self.dll.AUTDWaitResultFPGAStateList(handle, future)

    def wait_result_firmware_version_list(self, handle: HandlePtr, future: FfiFuture) -> ResultFirmwareVersionList:
        return self.dll.AUTDWaitResultFirmwareVersionList(handle, future)

    def tracing_init(self) -> None:
        return self.dll.AUTDTracingInit()

    def tracing_init_with_file(self, path: bytes) -> ResultStatus:
        return self.dll.AUTDTracingInitWithFile(path)

    def link_audit(self) -> LinkBuilderPtr:
        return self.dll.AUTDLinkAudit()

    def link_audit_is_open(self, audit: LinkPtr) -> ctypes.c_bool:
        return self.dll.AUTDLinkAuditIsOpen(audit)

    def link_audit_down(self, audit: LinkPtr) -> None:
        return self.dll.AUTDLinkAuditDown(audit)

    def link_audit_up(self, audit: LinkPtr) -> None:
        return self.dll.AUTDLinkAuditUp(audit)

    def link_audit_break_down(self, audit: LinkPtr) -> None:
        return self.dll.AUTDLinkAuditBreakDown(audit)

    def link_audit_repair(self, audit: LinkPtr) -> None:
        return self.dll.AUTDLinkAuditRepair(audit)

    def link_audit_last_timeout(self, audit: LinkPtr) -> OptionDuration:
        return self.dll.AUTDLinkAuditLastTimeout(audit)

    def link_audit_last_parallel_threshold(self, audit: LinkPtr) -> ctypes.c_int64:
        return self.dll.AUTDLinkAuditLastParallelThreshold(audit)

    def link_audit_cpu_num_transducers(self, audit: LinkPtr, idx: int) -> ctypes.c_uint32:
        return self.dll.AUTDLinkAuditCpuNumTransducers(audit, idx)

    def link_audit_fpga_assert_thermal_sensor(self, audit: LinkPtr, idx: int) -> None:
        return self.dll.AUTDLinkAuditFpgaAssertThermalSensor(audit, idx)

    def link_audit_fpga_deassert_thermal_sensor(self, audit: LinkPtr, idx: int) -> None:
        return self.dll.AUTDLinkAuditFpgaDeassertThermalSensor(audit, idx)

    def link_audit_fpga_is_force_fan(self, audit: LinkPtr, idx: int) -> ctypes.c_bool:
        return self.dll.AUTDLinkAuditFpgaIsForceFan(audit, idx)

    def link_audit_fpga_current_stm_segment(self, audit: LinkPtr, idx: int) -> Segment:
        return self.dll.AUTDLinkAuditFpgaCurrentStmSegment(audit, idx)

    def link_audit_fpga_current_mod_segment(self, audit: LinkPtr, idx: int) -> Segment:
        return self.dll.AUTDLinkAuditFpgaCurrentModSegment(audit, idx)

    def link_audit_fpga_is_stm_gain_mode(self, audit: LinkPtr, segment: Segment, idx: int) -> ctypes.c_bool:
        return self.dll.AUTDLinkAuditFpgaIsStmGainMode(audit, segment, idx)

    def link_audit_cpu_silencer_strict_mode(self, audit: LinkPtr, idx: int) -> ctypes.c_bool:
        return self.dll.AUTDLinkAuditCpuSilencerStrictMode(audit, idx)

    def link_audit_fpga_silencer_update_rate_intensity(self, audit: LinkPtr, idx: int) -> ctypes.c_uint16:
        return self.dll.AUTDLinkAuditFpgaSilencerUpdateRateIntensity(audit, idx)

    def link_audit_fpga_silencer_update_rate_phase(self, audit: LinkPtr, idx: int) -> ctypes.c_uint16:
        return self.dll.AUTDLinkAuditFpgaSilencerUpdateRatePhase(audit, idx)

    def link_audit_fpga_silencer_completion_steps_intensity(self, audit: LinkPtr, idx: int) -> Duration:
        return self.dll.AUTDLinkAuditFpgaSilencerCompletionStepsIntensity(audit, idx)

    def link_audit_fpga_silencer_completion_steps_phase(self, audit: LinkPtr, idx: int) -> Duration:
        return self.dll.AUTDLinkAuditFpgaSilencerCompletionStepsPhase(audit, idx)

    def link_audit_fpga_silencer_fixed_completion_steps_mode(self, audit: LinkPtr, idx: int) -> ctypes.c_bool:
        return self.dll.AUTDLinkAuditFpgaSilencerFixedCompletionStepsMode(audit, idx)

    def link_audit_fpga_silencer_target(self, audit: LinkPtr, idx: int) -> SilencerTarget:
        return self.dll.AUTDLinkAuditFpgaSilencerTarget(audit, idx)

    def link_audit_fpga_debug_types(self, audit: LinkPtr, idx: int, ty: ctypes.Array[ctypes.c_uint8] | None) -> None:
        return self.dll.AUTDLinkAuditFpgaDebugTypes(audit, idx, ty)

    def link_audit_fpga_debug_values(self, audit: LinkPtr, idx: int, value: ctypes.Array[ctypes.c_uint64] | None) -> None:
        return self.dll.AUTDLinkAuditFpgaDebugValues(audit, idx, value)

    def link_audit_fpga_stm_freq_division(self, audit: LinkPtr, segment: Segment, idx: int) -> ctypes.c_uint16:
        return self.dll.AUTDLinkAuditFpgaStmFreqDivision(audit, segment, idx)

    def link_audit_fpga_stm_cycle(self, audit: LinkPtr, segment: Segment, idx: int) -> ctypes.c_uint16:
        return self.dll.AUTDLinkAuditFpgaStmCycle(audit, segment, idx)

    def link_audit_fpga_sound_speed(self, audit: LinkPtr, segment: Segment, idx: int) -> ctypes.c_uint16:
        return self.dll.AUTDLinkAuditFpgaSoundSpeed(audit, segment, idx)

    def link_audit_fpga_stm_loop_behavior(self, audit: LinkPtr, segment: Segment, idx: int) -> LoopBehavior:
        return self.dll.AUTDLinkAuditFpgaStmLoopBehavior(audit, segment, idx)

    def link_audit_fpga_modulation_freq_division(self, audit: LinkPtr, segment: Segment, idx: int) -> ctypes.c_uint16:
        return self.dll.AUTDLinkAuditFpgaModulationFreqDivision(audit, segment, idx)

    def link_audit_fpga_modulation_cycle(self, audit: LinkPtr, segment: Segment, idx: int) -> ctypes.c_uint16:
        return self.dll.AUTDLinkAuditFpgaModulationCycle(audit, segment, idx)

    def link_audit_fpga_modulation_buffer(self, audit: LinkPtr, segment: Segment, idx: int, data: ctypes.Array[ctypes.c_uint8] | None, size: int) -> None:
        return self.dll.AUTDLinkAuditFpgaModulationBuffer(audit, segment, idx, data, size)

    def link_audit_fpga_modulation_loop_behavior(self, audit: LinkPtr, segment: Segment, idx: int) -> LoopBehavior:
        return self.dll.AUTDLinkAuditFpgaModulationLoopBehavior(audit, segment, idx)

    def link_audit_fpga_drives_at(self, audit: LinkPtr, segment: Segment, idx: int, stm_idx: int, drive: ctypes.Array | None) -> None:
        return self.dll.AUTDLinkAuditFpgaDrivesAt(audit, segment, idx, stm_idx, drive)

    def link_audit_fpga_pulse_width_encoder_table(self, audit: LinkPtr, idx: int, dst: ctypes.Array[ctypes.c_uint8] | None) -> None:
        return self.dll.AUTDLinkAuditFpgaPulseWidthEncoderTable(audit, idx, dst)

    def link_get(self, cnt: ControllerPtr) -> LinkPtr:
        return self.dll.AUTDLinkGet(cnt)

    def link_nop(self) -> LinkBuilderPtr:
        return self.dll.AUTDLinkNop()

    def modulation_cache(self, m: ModulationPtr) -> ModulationCachePtr:
        return self.dll.AUTDModulationCache(m)

    def modulation_cache_clone(self, m: ModulationCachePtr, loop_behavior: LoopBehavior) -> ModulationPtr:
        return self.dll.AUTDModulationCacheClone(m, loop_behavior)

    def modulation_cache_free(self, m: ModulationCachePtr) -> None:
        return self.dll.AUTDModulationCacheFree(m)

    def modulation_custom(self, config: SamplingConfig, loop_behavior: LoopBehavior, ptr: ctypes.Array[ctypes.c_uint8] | None, len: int) -> ModulationPtr:
        return self.dll.AUTDModulationCustom(config, loop_behavior, ptr, len)

    def modulation_custom_with_resample(self, loop_behavior: LoopBehavior, ptr: ctypes.Array[ctypes.c_uint8] | None, len: int, src: float, target: SamplingConfig, resample: DynSincInterpolator) -> ModulationPtr:
        return self.dll.AUTDModulationCustomWithResample(loop_behavior, ptr, len, src, target, resample)

    def modulation_with_fir(self, m: ModulationPtr, loop_behavior: LoopBehavior, coef: ctypes.Array[ctypes.c_float] | None, n_tap: int) -> ModulationPtr:
        return self.dll.AUTDModulationWithFir(m, loop_behavior, coef, n_tap)

    def modulation_fourier_exact(self, sine_freq: ctypes.Array[ctypes.c_uint32] | None, sine_config: ctypes.Array | None, sine_intensity: ctypes.Array[ctypes.c_uint8] | None, sine_offset: ctypes.Array[ctypes.c_uint8] | None, sine_phase: ctypes.Array[ctypes.c_float] | None, sine_clamp: ctypes.Array[ctypes.c_bool] | None, size: int, clamp: bool, scale_factor: float, offset: int, loop_behavior: LoopBehavior) -> ResultModulation:
        return self.dll.AUTDModulationFourierExact(sine_freq, sine_config, sine_intensity, sine_offset, sine_phase, sine_clamp, size, clamp, scale_factor, offset, loop_behavior)

    def modulation_fourier_exact_float(self, sine_freq: ctypes.Array[ctypes.c_float] | None, sine_config: ctypes.Array | None, sine_intensity: ctypes.Array[ctypes.c_uint8] | None, sine_offset: ctypes.Array[ctypes.c_uint8] | None, sine_phase: ctypes.Array[ctypes.c_float] | None, sine_clamp: ctypes.Array[ctypes.c_bool] | None, size: int, clamp: bool, scale_factor: float, offset: int, loop_behavior: LoopBehavior) -> ResultModulation:
        return self.dll.AUTDModulationFourierExactFloat(sine_freq, sine_config, sine_intensity, sine_offset, sine_phase, sine_clamp, size, clamp, scale_factor, offset, loop_behavior)

    def modulation_fourier_nearest(self, sine_freq: ctypes.Array[ctypes.c_float] | None, sine_config: ctypes.Array | None, sine_intensity: ctypes.Array[ctypes.c_uint8] | None, sine_offset: ctypes.Array[ctypes.c_uint8] | None, sine_phase: ctypes.Array[ctypes.c_float] | None, sine_clamp: ctypes.Array[ctypes.c_bool] | None, size: int, clamp: bool, scale_factor: float, offset: int, loop_behavior: LoopBehavior) -> ResultModulation:
        return self.dll.AUTDModulationFourierNearest(sine_freq, sine_config, sine_intensity, sine_offset, sine_phase, sine_clamp, size, clamp, scale_factor, offset, loop_behavior)

    def modulation_sampling_config(self, m: ModulationPtr) -> SamplingConfig:
        return self.dll.AUTDModulationSamplingConfig(m)

    def modulation_into_datagram_with_segment(self, m: ModulationPtr, segment: Segment, transition_mode: TransitionModeWrap) -> DatagramPtr:
        return self.dll.AUTDModulationIntoDatagramWithSegment(m, segment, transition_mode)

    def modulation_into_datagram(self, m: ModulationPtr) -> DatagramPtr:
        return self.dll.AUTDModulationIntoDatagram(m)

    def modulation_with_radiation_pressure(self, m: ModulationPtr, loop_behavior: LoopBehavior) -> ModulationPtr:
        return self.dll.AUTDModulationWithRadiationPressure(m, loop_behavior)

    def modulation_sine_exact(self, freq: int, config: SamplingConfig, intensity: int, offset: int, phase: float, clamp: bool, loop_behavior: LoopBehavior) -> ResultModulation:
        return self.dll.AUTDModulationSineExact(freq, config, intensity, offset, phase, clamp, loop_behavior)

    def modulation_sine_exact_float(self, freq: float, config: SamplingConfig, intensity: int, offset: int, phase: float, clamp: bool, loop_behavior: LoopBehavior) -> ResultModulation:
        return self.dll.AUTDModulationSineExactFloat(freq, config, intensity, offset, phase, clamp, loop_behavior)

    def modulation_sine_nearest(self, freq: float, config: SamplingConfig, intensity: int, offset: int, phase: float, clamp: bool, loop_behavior: LoopBehavior) -> ResultModulation:
        return self.dll.AUTDModulationSineNearest(freq, config, intensity, offset, phase, clamp, loop_behavior)

    def modulation_sine_exact_freq(self, freq: int) -> ctypes.c_uint32:
        return self.dll.AUTDModulationSineExactFreq(freq)

    def modulation_sine_exact_float_freq(self, freq: float) -> ctypes.c_float:
        return self.dll.AUTDModulationSineExactFloatFreq(freq)

    def modulation_sine_nearest_freq(self, freq: float) -> ctypes.c_float:
        return self.dll.AUTDModulationSineNearestFreq(freq)

    def modulation_sine_is_default(self, config: SamplingConfig, intensity: int, offset: int, phase: float, clamp: bool, loop_behavior: LoopBehavior) -> ctypes.c_bool:
        return self.dll.AUTDModulationSineIsDefault(config, intensity, offset, phase, clamp, loop_behavior)

    def modulation_square_exact(self, freq: int, config: SamplingConfig, low: int, high: int, duty: float, loop_behavior: LoopBehavior) -> ResultModulation:
        return self.dll.AUTDModulationSquareExact(freq, config, low, high, duty, loop_behavior)

    def modulation_square_exact_float(self, freq: float, config: SamplingConfig, low: int, high: int, duty: float, loop_behavior: LoopBehavior) -> ResultModulation:
        return self.dll.AUTDModulationSquareExactFloat(freq, config, low, high, duty, loop_behavior)

    def modulation_square_nearest(self, freq: float, config: SamplingConfig, low: int, high: int, duty: float, loop_behavior: LoopBehavior) -> ResultModulation:
        return self.dll.AUTDModulationSquareNearest(freq, config, low, high, duty, loop_behavior)

    def modulation_square_exact_freq(self, freq: int) -> ctypes.c_uint32:
        return self.dll.AUTDModulationSquareExactFreq(freq)

    def modulation_square_exact_float_freq(self, freq: float) -> ctypes.c_float:
        return self.dll.AUTDModulationSquareExactFloatFreq(freq)

    def modulation_square_nearest_freq(self, freq: float) -> ctypes.c_float:
        return self.dll.AUTDModulationSquareNearestFreq(freq)

    def modulation_square_is_default(self, config: SamplingConfig, low: int, high: int, duty: float, loop_behavior: LoopBehavior) -> ctypes.c_bool:
        return self.dll.AUTDModulationSquareIsDefault(config, low, high, duty, loop_behavior)

    def modulation_static(self, intensity: int, loop_behavior: LoopBehavior) -> ModulationPtr:
        return self.dll.AUTDModulationStatic(intensity, loop_behavior)

    def modulation_static_is_default(self, intensity: int) -> ctypes.c_bool:
        return self.dll.AUTDModulationStaticIsDefault(intensity)

    def get_err(self, src: ctypes.c_void_p | None, dst: ctypes.Array[ctypes.c_char] | None) -> None:
        return self.dll.AUTDGetErr(src, dst)
